WindowIcon = class( Turbine.UI.Window )

function WindowIcon:Constructor()
	Turbine.UI.Window.Constructor( self )

	self:SetSize(32,32)
	self:SetPosition(LootSettings["icon"]["left"], LootSettings["icon"]["top"])
	self:SetOpacity(0.5)

	self.notification_index = 1

	self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetSize(32,32)
    self.icon:SetMouseVisible(false)

	self.icon:SetBackground("Souru/LootLogs/Resources/chest.tga")

	self.notification_back = Turbine.UI.Window()
	self.notification_back:SetParent(self)
	self.notification_back:SetSize(200, 30)

	if self:GetLeft()-184 >= 0 then

		if self:GetLeft()+116 <= Turbine.UI.Display.GetWidth() then
			self.notification_back:SetPosition(-84, -35)
		else
			self.notification_back:SetPosition(-168, -35)
		end

	else
		self.notification_back:SetPosition(0, -35)
	end

	

	self.notification_lb = Turbine.UI.ListBox()
	self.notification_lb:SetParent(self.notification_back)
	self.notification_lb:SetSize(200, 30)
	self.notification_lb:SetReverseFill(true)
	self.notification_lb:SetFlippedLayout(true)
	self.notification_back:SetVisible(true)
	
	self:SetMouseVisible(true)
	self:SetVisible(true)
	
	self.MouseEnter = function(sender, args)
		self:SetOpacity(1)
		
		if LootSettings["show_notifications"] ~= false then
			self:ShowAllNotifications()
		end
    end

    self.MouseLeave = function(sender, args)
	   self:SetOpacity(0.5)
	   
		if LootSettings["show_notifications"] ~= false then
			self:HideAllNotifications()
	   end
	end
	
	self.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = true	
			self.dragStartX = args.X
			self.dragStartY = args.Y
		end
	end
	
	self.MouseMove = function( sender, args )
		if self.dragging then
			local x,y = self:GetPosition()
			x = x + ( args.X - self.dragStartX )
			y = y + ( args.Y - self.dragStartY )

			if x < 0 then
				x = 0
			end
			if y < 0 then
				y = 0
			end
			local max_x = Turbine.UI.Display.GetWidth() - self:GetWidth()
			local max_y = Turbine.UI.Display.GetHeight() - self:GetHeight()
			if x > max_x then
				x = max_x
			end
			if y > max_y then
				y = max_y
			end

			self:SetPosition( x, y )	

			if self:GetLeft()-184 >= 0 then

				if self:GetLeft()+116 <= Turbine.UI.Display.GetWidth() then
					self.notification_back:SetPosition(-84, -35)
				else
					self.notification_back:SetPosition(-168, -35)
				end
		
			else
				self.notification_back:SetPosition(0, -35)
			end

		end
	end
	
	self.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = false
			LootSettings["icon"]["left"],LootSettings["icon"]["top"] = self:GetPosition()
				
			SaveSettings()
		end
	end

	self.MouseClick = function(sender, args)

        if args.Button == Turbine.UI.MouseButton.Right then
			OpenSettings()
        end

	end

end

function WindowIcon:ShowAllNotifications()

	for i=1, self.notification_lb:GetItemCount(), 1 do
		self.notification_lb:GetItem(i):Show()
	end

end

function WindowIcon:HideAllNotifications()

	for i=1, self.notification_lb:GetItemCount(), 1 do
		self.notification_lb:GetItem(i):Hide()
	end

end

function WindowIcon:AddNotification(text)

	self.notification_lb:AddItem(NotificationItem(text, self.notification_index, self))
	self.notification_index  = self.notification_index + 1
	self.notification_lb:Sort(function(elem1,elem2) if elem1.index>elem2.index then return true end end)

end

function WindowIcon:RemoveNotification(control)

	-- self.notification_lb:RemoveItem(control)
	-- control.frame:SetVisible(false)
	-- control.foreground:SetVisible(false)
	-- control:SetVisible(false)
	-- control.frame:Close()
	-- control.foreground:Close()
	-- control:Close()

end


---------------------------------------------------------------------
--== Notification Item ===--
---------------------------------------------------------------------

NotificationItem = class( Turbine.UI.Window )

function NotificationItem:Constructor(text, index, parent)
	Turbine.UI.Window.Constructor( self )

	self:SetSize(200, 31)

	self.index = index
	self.hover = false
	self.parent = parent
	self.end_of_time = Turbine.Engine.GetGameTime() + 10

	self.frame = Turbine.UI.Window()
	self.frame:SetParent(self)
	self.frame:SetBackColor(Turbine.UI.Color.Red)
	self.frame:SetSize(200, 26)
	self.frame:SetOpacity(0.5)
	self.frame:SetZOrder(1)
	
	self.background = Turbine.UI.Control()
	self.background:SetParent(self.frame)
	self.background:SetPosition(1,1)
	self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
	self.background:SetSize(198, 24)

	self.foreground = Turbine.UI.Window()
	self.foreground:SetParent(self)
	self.foreground:SetPosition(1,1)
	self.foreground:SetSize(198, 24)
	self.foreground:SetZOrder(2)

	self.text = Turbine.UI.Label()
	self.text:SetParent(self.foreground)
	self.text:SetSize(198, 24)
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.text:SetForeColor(Turbine.UI.Color(0.8,0.8,0.8))
	self.text:SetMarkupEnabled(true)
	self.text:SetText(text)

	self.foreground:SetVisible(true)
	self.frame:SetVisible(true)
	self:SetVisible(true)

	if LootSettings["show_notifications"] ~= false then
		self:SetWantsUpdates(true)
	else
		self:SetVisible(false)
		self.frame:SetOpacity(1)
		self.foreground:SetOpacity(1)
	end

end

function NotificationItem:Show()

	self.hover = true

	self:SetVisible(true)
	self.frame:SetOpacity(1)
	self.foreground:SetOpacity(1)

end

function NotificationItem:Hide()

	self.hover = false

	self:SetVisible(self:GetWantsUpdates())

end

function NotificationItem:Update()

	local time_left = self.end_of_time - Turbine.Engine.GetGameTime()

	if self.hover == false then

		if time_left < 0 then

			self.parent:RemoveNotification(self)
			self:SetWantsUpdates(false)
			self:SetVisible(false)
			self.frame:SetOpacity(1)
			self.foreground:SetOpacity(1)

		elseif time_left < 2 then

			self.frame:SetOpacity(time_left/2)
			self.foreground:SetOpacity(time_left/2)

		elseif time_left < 2.5 then

			self.frame:SetOpacity(1-(time_left-2))

		end

	end

end